const should = require('should')
const _ = require('lodash')

describe('at-lodash', function () {
  // const at_lodash = require('../src/at-lodash')
  const ctx = {}
  require('at-lodash').call(ctx)
  describe('at-lodash', () => {
    it('should set function of lodash at execution context', function () {
      ctx.should.have.property('groupBy')
      ctx.should.have.propertyByPath('fp', 'map')
      ctx.should.have.propertyByPath('s', 'prune')
      ctx.should.have.property('version')
    })
  })
  describe('at-module', () => {
    const at_module = require('../src/at-module')
    const proto = at_module()
    it('should call just once', () => {
      at_module()
      // if it call one more, it thorw error because define same key in it
      at_module.should.not.throw()
    })
    it('should return object which is set of function in lodash', () => {
      proto.should.have.property('groupBy')
      proto.should.have.propertyByPath('fp', 'map')
      proto.should.have.propertyByPath('s', 'prune')
      // proto.should.have.property('version')
    })
    it('should set node-module at execution context', function () {
      proto.should.properties(proto.nodejs_module)
    })
    it('should set string function which create scope that has string type extended by stringjs', function () {
      proto.S(() => {
        'string'.should.have.property('humanize')
      })
      'string'.should.not.have.property('humanize')
    })
    describe('findUp', () => {
      const parentModuleDir = `${__dirname}/fixture/module1/src/`
      it(`(fileName, baseDir) should return file path from baseDir by up`, () => {
        proto.findUp('package.json', parentModuleDir).should.eql(
          proto.path.normalize('/Volumes/mac/3/jats/project/node_modules/at-lodash/test/fixture/module1')
        )
      })
    })
    describe('npm-module', function () {
      const dependency = proto.get_dependencies('../package.json')
      it('should set npm-module at execution context', function () {
        proto.should.property('lodash')
        proto.should.properties(dependency)
      })
    })
    describe('::user_config', function () {
      const configSrc1 = `${__dirname}/at.config.js`
      const configSrc2 = `${__dirname}/at.config.err.js`
      it('should set user_config in execution context', function () {
        // proto.user_config(configSrc2).should.throw(/^Cannot find module/)
        // proto.user_config.bind({}, configSrc2).should.throw(/is not a function$/)
        // proto.user_config.bind({}, configSrc1).should.not.throw()
        // ctx.should.have.a.properties('user_cfg')
      })
    })
  })
})

